summaryrefslogtreecommitdiff
path: root/tests/unibyte-negated-circumflex
diff options
context:
space:
mode:
authorPaul Eggert <eggert@cs.ucla.edu>2014-02-19 18:58:42 -0800
committerJim Meyering <meyering@fb.com>2014-02-20 13:36:09 -0800
commit1179952ef0728c6f8cb65214fc8be2732c2d27a3 (patch)
tree4ce03ced283dbf1d578139a8ed762480226fd9e3 /tests/unibyte-negated-circumflex
parentef5a3b579ed478a0755bae6858b02984d3bc1536 (diff)
downloadgrep-1179952ef0728c6f8cb65214fc8be2732c2d27a3.tar.gz
tests: test [^^-^] in unibyte locales
This is a bug in the current dfa.c, which was reintroduced by the recent reversion from RRI. * tests/unibyte-negated-circumflex: New file. * tests/Makefile.am (TESTS): Add it. * tests/init.cfg (require_unibyte_locale): New function.
Diffstat (limited to 'tests/unibyte-negated-circumflex')
-rwxr-xr-xtests/unibyte-negated-circumflex27
1 files changed, 27 insertions, 0 deletions
diff --git a/tests/unibyte-negated-circumflex b/tests/unibyte-negated-circumflex
new file mode 100755
index 00000000..b6d747c8
--- /dev/null
+++ b/tests/unibyte-negated-circumflex
@@ -0,0 +1,27 @@
+#!/bin/sh
+# Exercise a bug where [^^-^] was treated as if it were [^-^].
+
+# Copyright 2014 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+require_unibyte_locale
+
+fail=0
+
+echo a >in || framework_failure_
+grep '[^^-^]' in >out || fail=1
+compare out in || fail=1
+Exit $fail